/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package fernandez_sanchez_abraham_PROG07_Tarea;

import java.beans.PropertyVetoException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;
import persistencia.EmpleadoClass;
import persistencia.UtilClass;


/**
 *
 * @author Abraham Fernandez Sanchez
 */
public final class WindowNewEmpleado extends javax.swing.JInternalFrame {
    /**
     * Declaracion de las variables
     */
    private String nombre;
    private String apellidos;
    private String titulacion;    
    private String direccion;
    private String nif;
    private int telefono;
    private int edad;
    private String fechaAlta;
    private boolean interino;
    private String nombreTrabajo;
    
    /**
     * Instanciacion de los objetos de las clases externas utilizadas
     */
    EmpleadoClass empleado;
    UtilClass util;
    

    /**
     * Creates new form WindowNewProfesor
     */
    public WindowNewEmpleado() {
        initComponents();
        jCheckBoxInterino.setVisible(false);
        loadComboBoxTrabajos();
    }

    /**
     * Metodo que introduce los trabajos existentes en persistencia en el JCombo box
     */
    public void loadComboBoxTrabajos(){
        util = new UtilClass();
        int size = util.sizeListaTrabajos();  
        for (int i = 0; i < size; i++) {
            nombreTrabajo = util.getTrabajo(i);
            jComboBoxTitulacion.insertItemAt(nombreTrabajo, i);            
        }            
    }
    
    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jSeparator1 = new javax.swing.JSeparator();
        jButtonGuardar = new javax.swing.JButton();
        jButtonReset = new javax.swing.JButton();
        jButtonCancelar = new javax.swing.JButton();
        jTextFieldFechaAlta = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jTextFieldNif = new javax.swing.JTextField();
        jTextFieldEdad = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        jTextFieldDireccion = new javax.swing.JTextField();
        jCheckBoxInterino = new javax.swing.JCheckBox();
        jComboBoxTitulacion = new javax.swing.JComboBox<>();
        jLabel4 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jTextFieldApellidos = new javax.swing.JTextField();
        jTextFieldNombre = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jLabel8 = new javax.swing.JLabel();
        jTextFieldTelefono = new javax.swing.JTextField();

        setClosable(true);
        setIconifiable(true);
        setMaximizable(true);
        setResizable(true);
        setTitle("Nuevo empleado");

        jButtonGuardar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fernandez_sanchez_abraham_PROG07_Tarea/iconos/FontAwesome_f00c(3)_32.png"))); // NOI18N
        jButtonGuardar.setText("Guardar");
        jButtonGuardar.setToolTipText("Guardar los datos");
        jButtonGuardar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonGuardarActionPerformed(evt);
            }
        });

        jButtonReset.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fernandez_sanchez_abraham_PROG07_Tarea/iconos/FontAwesome_f05e(8)_32.png"))); // NOI18N
        jButtonReset.setText("Reset");
        jButtonReset.setToolTipText("Deshacer los cambios");
        jButtonReset.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonResetActionPerformed(evt);
            }
        });

        jButtonCancelar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/fernandez_sanchez_abraham_PROG07_Tarea/iconos/FontAwesome_f00d(2)_32.png"))); // NOI18N
        jButtonCancelar.setText("Cancelar");
        jButtonCancelar.setToolTipText("Cancelar la accion");
        jButtonCancelar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonCancelarActionPerformed(evt);
            }
        });

        jLabel7.setText("F. Alta: ");

        jLabel6.setText("Edad: ");

        jLabel5.setText("NIF: ");

        jLabel3.setText("Direccion: ");

        jCheckBoxInterino.setText("Interino");

        jComboBoxTitulacion.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jComboBoxTitulacionActionPerformed(evt);
            }
        });

        jLabel4.setText("Titulacion: ");

        jLabel2.setText("Apellidos: ");

        jLabel1.setText("Nombre: ");

        jLabel8.setText("Teléfono: ");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jSeparator1)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButtonGuardar)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(jButtonReset)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jButtonCancelar))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jLabel3, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(jLabel5, javax.swing.GroupLayout.Alignment.LEADING)
                                .addComponent(jLabel4, javax.swing.GroupLayout.Alignment.LEADING))
                            .addComponent(jLabel1))
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextFieldNombre)
                            .addComponent(jTextFieldNif)
                            .addComponent(jTextFieldDireccion)
                            .addComponent(jTextFieldApellidos)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jComboBoxTitulacion, javax.swing.GroupLayout.PREFERRED_SIZE, 127, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 93, Short.MAX_VALUE)
                                .addComponent(jCheckBoxInterino))))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                            .addComponent(jLabel6, javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel7, javax.swing.GroupLayout.Alignment.LEADING))
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jTextFieldEdad)
                            .addComponent(jTextFieldFechaAlta)))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel8)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldTelefono)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(15, 15, 15)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(jTextFieldNombre, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jTextFieldApellidos, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jCheckBoxInterino)
                    .addComponent(jComboBoxTitulacion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(10, 10, 10)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jTextFieldDireccion, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(jTextFieldNif, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(jTextFieldTelefono, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(jTextFieldEdad, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel7)
                    .addComponent(jTextFieldFechaAlta, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 8, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonGuardar)
                    .addComponent(jButtonReset)
                    .addComponent(jButtonCancelar))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonGuardarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonGuardarActionPerformed
        try {    
            nombre = jTextFieldNombre.getText();
            apellidos = jTextFieldApellidos.getText();
            titulacion = jComboBoxTitulacion.getItemAt(jComboBoxTitulacion.getSelectedIndex());
            direccion = jTextFieldDireccion.getText();
            nif = jTextFieldNif.getText();
            telefono = Integer.parseInt(jTextFieldTelefono.getText());
            edad = Integer.parseInt(jTextFieldEdad.getText());
            fechaAlta = jTextFieldFechaAlta.getText();
            interino = jCheckBoxInterino.isSelected();
            accionGuardar();
            try {            
                confirmacionAccion();
            } catch (PropertyVetoException ex) {
                Logger.getLogger(WindowNewEmpleado.class.getName()).log(Level.SEVERE, null, ex);
            }
        } catch (NumberFormatException  e) {
            JOptionPane.showMessageDialog(this, "Los campos 'telefono' y 'edad' son numericos, introdúzcalos correctamente ");
        }        
    }//GEN-LAST:event_jButtonGuardarActionPerformed

    /**
     * Metodo para confirmar la accion de guardar un nuevo empleado y en el caso afirmativo seguir introduciendo otros usuarios o no <br>
     * @throws java.beans.PropertyVetoException Exception 
     */
    public void confirmacionAccion() throws PropertyVetoException{    
            //0=SI - 1=NO 
            String mensaje = "¿ Quieres seguir creando un nuevo empleado ?";
            int respuesta = JOptionPane.showConfirmDialog(null, mensaje, "Confirmación", JOptionPane.YES_NO_OPTION, JOptionPane.INFORMATION_MESSAGE);
            if(respuesta==0){                
                clearJText();
            }else{  
                try {
                    this.setClosed(true);            
                } catch (PropertyVetoException ex) {
                    Logger.getLogger(WindowNewEmpleado.class.getName()).log(Level.SEVERE, null, ex);
                } 
            }    
    }
    
    private void jButtonCancelarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonCancelarActionPerformed
        try {
            this.setClosed(true);            
        } catch (PropertyVetoException ex) {
            Logger.getLogger(WindowNewEmpleado.class.getName()).log(Level.SEVERE, null, ex);
        }
    }//GEN-LAST:event_jButtonCancelarActionPerformed

    private void jComboBoxTitulacionActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jComboBoxTitulacionActionPerformed
       titulacion = jComboBoxTitulacion.getItemAt(jComboBoxTitulacion.getSelectedIndex());
        if(titulacion.equalsIgnoreCase("profesor")){
            jCheckBoxInterino.setVisible(true);
        }else{
            jCheckBoxInterino.setVisible(false);
        }        
    }//GEN-LAST:event_jComboBoxTitulacionActionPerformed

    private void jButtonResetActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonResetActionPerformed
        clearJText();
    }//GEN-LAST:event_jButtonResetActionPerformed

    /**
     * Metodo que reune las diferentes acciones que debe realizar el sistema cuando se clickea en el boton guardar
     */
    private void accionGuardar(){
            empleado = new EmpleadoClass(nombre, apellidos, titulacion, direccion, nif, telefono, edad, fechaAlta, interino);            
            util = new UtilClass();
            util.addNewEmpleado(empleado);   
    }
    
    /**
     * Metodo para limpiar los valores de los campos de texto
     */
    public void clearJText(){    
        jTextFieldNombre.setText("");
        jTextFieldApellidos.setText("");
        jComboBoxTitulacion.setSelectedIndex(0);
        jTextFieldDireccion.setText("");
        jTextFieldNif.setText("");
        jTextFieldTelefono.setText("");
        jTextFieldEdad.setText("");
        jTextFieldFechaAlta.setText("");
        jCheckBoxInterino.setSelected(false);    
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonCancelar;
    private javax.swing.JButton jButtonGuardar;
    private javax.swing.JButton jButtonReset;
    private javax.swing.JCheckBox jCheckBoxInterino;
    private javax.swing.JComboBox<String> jComboBoxTitulacion;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTextField jTextFieldApellidos;
    private javax.swing.JTextField jTextFieldDireccion;
    private javax.swing.JTextField jTextFieldEdad;
    private javax.swing.JTextField jTextFieldFechaAlta;
    private javax.swing.JTextField jTextFieldNif;
    private javax.swing.JTextField jTextFieldNombre;
    private javax.swing.JTextField jTextFieldTelefono;
    // End of variables declaration//GEN-END:variables
}
